@Echo Off
::  Save any values globally for later use

::  Isolate varables after global save
    SetLocal EnableDelayedExpansion

::  Customize shell list with optional arguments
    If /I "%~1" EQU "/New" (
        If Exist "%~n0.txt" Erase "%~n0.txt"
        Call :ListShells
    )

    CLS
    Echo.List of available Windows shells on this PC:
    Echo.
    Type "%~n0.txt"

Window Size
call :GetCoords Cols= Lines=
echo Current window SCREEN size is %Cols% columns X %Lines% lines
set Cols=
set Lines=
for /F "skip=2 tokens=2" %%a in ('mode con') do (
   if not defined Lines (
      set Lines=%%a
   ) else if not defined Cols (
      set Cols=%%a
   )
)
echo Current window BUFFER size is %Cols% columns X %Lines% lines
CursorPos
set lastPos=%errorlevel%
call :GetCoords lastCol= lastRow=
echo. Cursor is PAUSEd at Position %lastCol% of line %lastRow% with Flags %lastPos%.
CursorPos %lastPos%
>nul Pause
echo.Cursor was
echo.Now looking for mouse input

   GetInput
   if %errorlevel% gtr 0 (
      echo Key pressed: %errorlevel%
   ) else (
      rem Mouse button clicked
      set /A "input=-%errorlevel%, row=input >> 16, col=input & 0xFFFF"
      if !col! lss 32768 (
         echo LEFT button click at !row!,!col!
      ) else (
         set /A col-=32768
         echo RIGHT button click at !row!,!col!
      )
   )

Call MChoice "%~n0.txt" xShell

%xShell%

Exit /B

:nextInput
   GetInput /t 30000 /M 0 0 80 140
   set /A "input=%errorlevel%, ctrl=input+32, asc=input-32, alt=input-192, ext=input-256&0xFF"
   if %input% gtr 0 (
      echo Key pressed: %errorlevel%
   ) else ( rem %input% leq 0
      Echo.Mouse button clicked
      set /A "input=-input, row=input >> 16, col=input & 0xFFFF"
      if !col! lss 32768 (
         echo LEFT @ !row!,!col!
      ) else (
         set /A col-=32768
         echo                                                                 @ !row!,!col! RIGHT
      )
      call :GetMouseCoords %input%
   )
if %input% neq 27 goto nextInput
goto :EOF

Exit /B

:ListShells
::  Refresh the shells list from the Registry
    Set "RowCtr=0"
   (
    For /f "usebackq tokens=1 delims= " %%H in (`
            reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\FolderDescriptions"
       `) do (
            For /f "usebackq tokens=1-2* delims= " %%R in (`
                Reg query "%%H"
           `) do (
                If /I "%%R" EQU "Name" (
                    Set /A "RowCtr+=1"
                    Echo(Start "" "Shell:%%T"
                )
            )
        )
    ) > "%~n0.txt"

   (
    Echo(
    Echo(Rem.Click to see where the shell leads you
    Echo(
    ) >> "%~n0.txt"

Exit /B

:GetCoords Cols= Lines=
    set /A "%1=%errorlevel%&0xFFFF, %2=(%errorlevel%>>16)&0xFFFF"
exit /B

:GetMouseCoords MR
Set "MR=%~1"
set /a "KEY=(%MR%>>22), MOUSE_EVENT=%MR% & 1, LMB=(%MR% & 2)>>1, RMB=(%MR% & 4)>>2, LDBL=(%MR% & 8)>>3, RDBL=(%MR% & 16)>>4, MWD=(%MR% & 32)>>5, MWU=(%MR% & 64)>>6, MX=(%MR%>>7) & 255, MY=(%MR%>>15) & 127"
if "%MOUSE_EVENT%"=="0" echo Errorlevel says: Key value: %KEY% & goto SKIP
echo Errorlevel says: Mouse x,y: %MX%,%MY% LMB=%LMB% RMB=%RMB% LDBL=%LDBL% RDBL=%RDBL% UP=%MWU% DOWN=%MWD%
:Skip
exit /B

